%%
%% This is file `lnotes.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% notes.cmd  (with options: `lnotes')
%%
%%   Copyright 1995
%%   Anders G S Svensson   <svensson@math.ubc.ca>
%%
%%   Please do not modify this file.
%%
\def\Revision@$#1 #2 ${v#2}
\def\Date@$#1 #2 #3 ${#2}


\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{lnotes}[\Date@$Date: 1996/01/21 11:16:19 $
    Long Notes Class \Revision@$Revision: 1.15 $]

\def\UnsupportedOption@#1{%
   \DeclareOption{#1}{\ClassError{lnotes}{Option "#1" unsupported}{Sorry.}}}

\newif\ifLettersect@
\DeclareOption{lettersect}{\Lettersect@true}
  
\DeclareOption{numbersect}{\Lettersect@false
   \AtEndOfClass{\renewcommand\thesection{\@arabic\c@section}}}

\DeclareOption{nodot}{\AtEndOfClass{\let\Dot@\relax}}
\DeclareOption{dot}{\AtEndOfClass{\def\Dot@{\rlap{.}}}}

  
\DeclareOption{balance}{%  
   \AtBeginDocument{\oddsidemargin\paperwidth
                    \addtolength\oddsidemargin{-\textwidth}
                    \divide\oddsidemargin by 2
                    \evensidemargin\oddsidemargin}}

\DeclareOption{openup}{%
   \AtEndOfClass{\def\baselinestretch{1.16}\advance\parskip by 2pt}}

   
\DeclareOption{indent}{\AtEndOfClass{\parskip\z@ \parindent20pt}}


\newif\ifdoublespace
\DeclareOption{doublespace}{\doublespacetrue}
   

\UnsupportedOption@{twocolumn}


\DeclareOption*{\PassOptionsToClass{\CurrentOption}{report}}

\ProcessOptions\relax
\LoadClass{report}
                    
\setlength\parindent{\z@}

\let\listi@\@listi
\def\@listi{\listi@ \paradjust@\topsep\listparstretch}

\ifcase\@ptsize\relax
   \setlength\parskip{6pt plus 1pt minus 1pt}
\or
   \setlength\parskip{6.5pt plus 1pt minus 1pt}
\or
   \setlength\parskip{7pt plus 1pt minus 1pt}
\fi
\let\@listI\@listi

\ifdoublespace
   \AtBeginDocument{\advance\parskip by \parstretch\parskip}
   \def\parstretch{1.6}
   \def\sectparstretch{.25}
   \def\listparstretch{0}
   \def\baselinestretch{1.6}
   \advance\skip\footins by .8\skip\footins\relax
\else
   \def\sectparstretch{.5}
   \def\listparstretch{.25}
\fi

\def\paradjust@#1#2{%
   \advance#1 by -\parskip
   \advance#1 by #2\parskip}
   
   
\def\single{\def\baselinestretch{1}\selectfont}
   
\setlength\oddsidemargin{.25in}
\setlength\evensidemargin{.25in}

\setlength\marginparsep{7\p@}
\setlength\marginparwidth{1.25in}
\addtolength\marginparwidth{-17\p@}
   
\setlength\textwidth{\paperwidth}
\addtolength\textwidth{-2.5in}

\setlength\headsep{20\p@} 
\setlength\footskip{30\p@} 
   
\setlength\textheight{\paperheight}
\addtolength\textheight{-120\p@}
\addtolength\textheight{-\footskip}
\addtolength\textheight{-\headsep}
\setlength\topmargin{\z@}
\addtolength\voffset{-1in}
\addtolength\voffset{-\headheight}
\addtolength\voffset{55\p@}

\renewcommand\@makefntext[1]{\leavevmode\hbox to \z@{\hss\@makefnmark}#1}

\ifLettersect@
   \def\Dot@{\rlap{.}}
   \renewcommand\thesection{\@Alph\c@section}
   \renewcommand\thesubsection{\@arabic\c@subsection}
   \renewcommand\thesubsubsection{\@alph\c@subsubsection}
   \renewcommand\appendix{\par \let\appendix\relax
      \setcounter{chapter}{0}\setcounter{section}{0}%
      \renewcommand\@chapapp{\appendixname}%
      \let\addchapcontentsline\addappcontentsline
      \renewcommand\thechapter{\@Alph\c@chapter}}
\else
   \let\Dot@\relax
   \renewcommand\appendix{\par \let\appendix\relax
      \setcounter{chapter}{0}\setcounter{section}{0}%
      \renewcommand\@chapapp{\appendixname}%
      \let\addchapcontentsline\addappcontentsline
      \renewcommand\thechapter{\@Alph\c@chapter}}
\fi

\renewenvironment{abstract}{\clearpage\chapter*{\abstractname}}{\clearpage}

\def\nostretch@{\def\baselinestretch{1}}
   
\def\revision#1{\gdef\@revision{#1}}
\let\@revision\relax
   
\renewenvironment{titlepage}
    {\thispagestyle{empty}\setcounter{page}\@ne\parskip\z@\parindent\z@
     \nostretch@\normalfont}%
    {\newpage\setcounter{page}\@ne}
      
\if@titlepage
   \renewcommand\maketitle{%
      \begin{titlepage}%
         \let\footnoterule\relax
         \let \footnote \thanks
         \null\vfil
         \vskip 60\p@
         \begin{center}%
            {\hfnt@title\@title\par
             \vskip 1.5em}%
            {\hfnt@author
             \lineskip.75em
             \begin{tabular}[t]{c}%
                \@author
             \end{tabular}\par
             \vskip 1.5em}%
            {\hfnt@date
             \@date\par
             \ifx\@revision\relax\else(\@revision)\par\fi}%
         \end{center}%
         \@thanks
         \vfil\null
      \end{titlepage}%
      \setcounter{footnote}{0}%
      \global\let\thanks\relax  
      \global\let\maketitle\relax
      \global\let\@thanks\@empty
      \global\let\@author\@empty
      \global\let\@date\@empty
      \global\let\@title\@empty
      \global\let\title\relax
      \global\let\author\relax
      \global\let\date\relax
      \global\let\and\relax}
\else
   \renewcommand\maketitle{\par
      \begingroup
         \parskip\z@\parindent\z@
         \renewcommand\thefootnote{\@fnsymbol\c@footnote}%
         \def\@makefnmark{\rlap{\@textsuperscript{\normalfont\@thefnmark}}}%
         \long\def\@makefntext##1{%
            \hb@xt@1.8em{\hss\@textsuperscript{\normalfont\@thefnmark}}##1}%
         \newpage  
         \global\@topnum\z@
         \@maketitle
         \thispagestyle{plain}\@thanks
      \endgroup
      \setcounter{footnote}{0}% 
      \global\let\thanks\relax  
      \global\let\maketitle\relax
      \global\let\@maketitle\relax
      \global\let\@thanks\@empty
      \global\let\@author\@empty
      \global\let\@date\@empty
      \global\let\@title\@empty
      \global\let\title\relax
      \global\let\author\relax 
      \global\let\date\relax
      \global\let\and\relax}
   \def\@maketitle{%
      \newpage
      \begingroup
         \nostretch@
         \parskip\z@ \parindent\z@
         \let \footnote \thanks
         {\hfnt@title\@title\par
          \vskip .5em}%
         {\hfnt@author \let\and\och@
          \lineskip.3em
          \begin{tabular}[t]{@{}l}%
             \@author
          \end{tabular}%
          \vskip .6em}%
         {\hfnt@date\@date\par  
          \ifx\@revision\relax\else\quad(\@revision)\par\fi
          \vskip 1.5em}
      \endgroup
      \vskip-\parskip}
\fi
      
\def\and{%
   \end{tabular}\vskip .5em
   \begin{tabular}[t]{c}}
         
\def\och@{%
   \end{tabular}\vskip .5em
   \begin{tabular}[t]{@{}l}}
          
\def\email#1{\leavevmode{\mdseries\ttfamily
   \lower.8pt\hbox{<}#1\lower.8pt\hbox{>}}}
          
\AtBeginDocument{\let\Title@\title
   \def\title#1{\Title@{#1}\maketitle \let\maketitle\relax}}
          
\def\tocsectionindent{1.5em}    
\def\tocspacer{.85em}
\def\headingslug{.85em}
\def\tocindent{1.5em}
      
   
      
\setcounter{secnumdepth}{2}
\setcounter{tocdepth}{2}   
   
\def\settocnnw@#1{%
   {\settowidth\@tempdima{\normalfont\mdseries\csname the#1\endcsname}%
    \expandafter\ifdim\@tempdima>\csname tocnnw@#1@\endcsname\relax
      \expandafter\xdef\csname tocnnw@#1@\endcsname{\the\@tempdima}%
   \fi}}  

\def\addcontentsline#1#2#3{%
   {\def\numberline##1{\settocnnw@{#2}}%
    \setbox\@tempboxa\hbox{#3}}%  
   \addtocontents{#1}{\protect\contentsline{#2}{#3}{\thepage}}}
          
\newwrite\ncaout@

\AtBeginDocument{%
   \begingroup
      \InputIfFileExists{\jobname.nca}
         {\makeatletter}{\typeout{No file \jobname.nca.}}%
   \endgroup
   \immediate\openout\ncaout@=\jobname.nca\relax}

   
\def\recordtocnw#1{%
   \expandafter\def\csname tocnw@#1@\endcsname{0pt}%
   \expandafter\def\csname tocnnw@#1@\endcsname{0pt}%
   \AtEndDocument{\immediate\write\ncaout@{%
      \noexpand\tocnw@{#1}{\csname tocnnw@#1@\endcsname}}}}

\recordtocnw{section}
\recordtocnw{subsection}
\recordtocnw{subsubsection}
\recordtocnw{paragraph}
\recordtocnw{subparagraph}
\recordtocnw{figure}
\recordtocnw{table}

\def\tocnw@#1#2{\expandafter\gdef\csname tocnw@#1@\endcsname{#2}}
      
         
\renewcommand\@dotsep{1.5}
   
\def\Dotfill@{\leavevmode
   \cleaders\hbox{$\m@th\mkern \@dotsep mu.\mkern \@dotsep
mu$}\hfill\kern\z@}

\renewcommand\tableofcontents{\let\tableofcontents\relax
   \tochook@
   \chapter*{\contentsname}%
   \@starttoc{toc}}

\let\@starttoc@\@starttoc
\def\@starttoc#1{%
   \begingroup
      \nostretch@\normalfont
      \let\newtocline@\par
      \parskip\z@   
      \@starttoc@{#1}\par
   \endgroup}

\def\newtocline{\protect\newtocline@}
\let\newtocline@\space

\def\tochook@{%
   {\normalfont\mdseries 
    \@tempdima\tocsectionindent\relax
    \xdef\section@indent{\the\@tempdima}%
    \@tempdimb\tocnw@section@\relax
    \SetIndents@
       {subsection}1{subsubsection}2{paragraph}3{subparagraph}4{}{}%
    \advance\@tempdima by \@tempdimb
    \advance\@tempdima by \tocspacer\relax
    \xdef\subsubparagraph@indent{\the\@tempdima}}}

\def\SetIndents@#1#2{%
   \def\action@{#1}%
   \ifx\action@\@empty
      \let\action@\relax
   \else
      \ifnum\c@secnumdepth<#2\relax
         \advance\@tempdima by \tocindent\relax
      \else
         \advance\@tempdima by \@tempdimb
         \advance\@tempdima by \tocspacer\relax
         \@tempdimb\csname tocnw@#1@\endcsname\relax
      \fi
      \expandafter\xdef\csname #1@indent\endcsname{\the\@tempdima}%
      \let\action@\SetIndents@
   \fi
   \action@}
       
\def\Bfseries@{\mathversion{bold}\bfseries}
    
\renewcommand*\l@part[2]{%
   \ifnum \c@tocdepth >-2\relax
      \addpenalty{-\@highpenalty}%
      \addvspace{2.25em \@plus\p@}%
      \begingroup
         \parindent\z@ \parfillskip\z@
         \leavevmode\large
         {\Bfseries@ #1\hfil #2}\par
         \nobreak
         \global\@nobreaktrue
         \everypar{\global\@nobreakfalse\everypar{}}%
      \endgroup
   \fi}
         
\def\partnumberline#1{\partname~#1.\Spacer@}
\def\Spacer@{\hskip\tocspacer\relax}
\def\Slug@{\hskip\headingslug\relax}
   
\renewcommand*\l@chapter[2]{%
   \ifnum \c@tocdepth >\m@ne
      \addpenalty{-\@highpenalty}%
      \vskip 1.0em \@plus\p@
      \begingroup
         \parindent\z@ %\parfillskip\z@
         \leavevmode{\Bfseries@ #1\hfill #2\par}%
         \penalty\@highpenalty
      \endgroup
      \vskip .2em \@plus\p@
   \fi}
         
\def\chapnumberline#1{%
   \settowidth\leftskip{\chaptername~#1.\Spacer@}%   
   \llap{\chaptername~#1.\Spacer@}}
\def\appnumberline#1{%
   \settowidth\leftskip{\appendixname~#1.\Spacer@}%
   \llap{\appendixname~#1.\Spacer@}}

\def\Dottedtocline@#1#2#3#4#5{%
   \ifnum #1>\c@tocdepth
   \else
      \vskip \z@ \@plus.2\p@
      \begingroup
         \leftskip #3\relax \parindent\z@ \parfillskip\z@ plus 1fil
         \rightskip\textwidth \advance\rightskip by -\tocwidth@
         \interlinepenalty\@M
         \def\numberline##1{\llap{\hbox to #3{\hskip#2##1\Dot@\hss}}}%
         \advance\tocwidth@ by -#3\relax
         \leavevmode #4\ \Dotfill@\ #5\par
      \endgroup
   \fi}
         
\renewcommand*\l@section{%
   \Dottedtocline@{1}\section@indent\subsection@indent}
\renewcommand*\l@subsection{%
   \Dottedtocline@{2}\subsection@indent\subsubsection@indent}
\renewcommand*\l@subsubsection{%
   \Dottedtocline@{3}\subsubsection@indent\paragraph@indent}
\renewcommand*\l@paragraph{%
   \Dottedtocline@{4}\paragraph@indent\subparagraph@indent}
\renewcommand*\l@subparagraph{%
   \@dottedtocline{5}\subparagraph@indent\subsubparagraph@indent}
      
\newdimen\tocwidth@
\AtBeginDocument{\tocwidth@\tocwidth\relax}
\def\tocwidth{\textwidth}
         
\renewcommand\listoffigures{\let\listoffigures\relax
   \genhook@{figure}%
   \chapter*{\listfigurename}%
   \@starttoc{lof}}
   
\renewcommand\listoftables{\let\listoftables\relax
   \genhook@{table}%
   \chapter*{\listtablename}%
   \@starttoc{lot}}
   

\def\genhook@#1{%
   {\@tempdima\csname tocnw@#1@\endcsname\relax
    \advance\@tempdima by \tocspacer\relax
    \expandafter\xdef\csname tocnw@#1@\endcsname{\the\@tempdima}}}
   
\renewcommand*\l@figure{\Dottedtocline@{1}{\z@}\tocnw@figure@}
\renewcommand*\l@table{\Dottedtocline@{1}{\z@}\tocnw@table@}


\def\headingfont#1#2{\expandafter\def\csname hfnt@#1\endcsname{#2}}

\headingfont{title}{\huge\bfseries\boldmath}
\headingfont{author}{\large\mdseries}
\headingfont{date}{\large\mdseries}
\headingfont{Part}{\Huge\mdseries}
\headingfont{part}{\huge\bfseries\boldmath}
\headingfont{spart}{\huge\bfseries\boldmath}
\headingfont{Chapter}{\Huge\mdseries}
\headingfont{chapter}{\huge\bfseries\boldmath}
\headingfont{schapter}{\huge\bfseries}
\headingfont{section}{\Large\bfseries\boldmath}
\headingfont{subsection}{\large\bfseries\boldmath}
\headingfont{subsubsection}{\normalfont\bfseries\boldmath}
    
    
\renewcommand\part{\cleardoublepage
   \thispagestyle{plain}%
   \@tempswafalse
   \null\vfil
   \secdef\@part\@spart}

\def\@part[#1]#2{%
   \ifnum \c@secnumdepth >\m@ne
      \refstepcounter{part}%
      \addcontentsline{toc}{part}{\protect\partnumberline{\thepart}#1}%
   \else
      \addcontentsline{toc}{part}{#1}%
   \fi
   \Makeparthead@{#2}}


\def\Makeparthead@#1{%
   \markboth{}{}%
   {\centering
    \interlinepenalty \@M
    \nostretch@\normalfont
    \parskip\z@
    \ifnum \c@secnumdepth >-2
       \hfnt@Part\partname~\thepart
       \vskip 20\p@
    \fi
    \hfnt@part #1\par
   }%
   \vfil\newpage}
      
      
\def\@spart#1{%
   \addtocontents{toc}{\protect\addvspace{1.5em}}%
   {\centering
    \interlinepenalty \@M
    \nostretch@\normalfont
    \hfnt@spart #1\par
   }%
   \vfil\newpage}
   
\renewcommand\chapter{\clearpage
   \thispagestyle{plain}% 
   \global\@topnum\z@
   \@afterindentfalse
   \secdef\@chapter\@schapter}
       
\def\@chapter[#1]#2{%
   \ifnum \c@secnumdepth>\m@ne\relax
      \refstepcounter{chapter}%
      \typeout{\@chapapp\space\thechapter.}%
      \addchapcontentsline{toc}{chapter}{#2}%
   \else
      \addcontentsline{toc}{chapter}{#2}%
   \fi
   \addtocontents{lof}{\protect\addvspace{10\p@}}%
   \addtocontents{lot}{\protect\addvspace{10\p@}}%
   \@makechapterhead{#2}% 
   \chaptermark{#1}%  
   \@afterheading}
   
\def\addchapcontentsline#1#2#3{%
   \addcontentsline{#1}{#2}{\protect\chapnumberline{\thechapter}#3}}
\def\addappcontentsline#1#2#3{
   \addcontentsline{#1}{#2}{\protect\appnumberline{\thechapter}#3}}
   
% CBM CHANGE THIS:
%\def\@makechapterhead#1{%
%  {\parindent\z@ \parskip5pt\raggedright\nostretch@\normalfont
%    \ifnum \c@secnumdepth >\m@ne
%       \hfnt@Chapter\@chapapp~\thechapter\par
%    \fi
%    \interlinepenalty\@M
%    \hfnt@chapter #1 \vskip2cm
%  }
  %  Since \parskip is applied when we re-enter horizontal mode, make sure the
  %  total vertical skip is independent of this value.
%  \vskip-\parskip}
   
\def\@schapter#1{%
   \@makeschapterhead{#1}%
   \schaptermark{#1}%
   \@afterheading}

\def\@makeschapterhead#1{%
   {\parindent \z@ \parskip8pt \raggedright \nostretch@\normalfont
    \hfnt@schapter #1\vskip20\p@
   }%
   \vskip-\parskip}
  
\def\@seccntformat#1{\csname the#1\endcsname\Dot@\Slug@}
       
\newskip\Beforeskip@
\newskip\Afterskip@
\def\sectparstretch{.5}
    
  
\renewcommand\section{%
   \@startsection{section}{1}{\z@}%
                 {-3.5ex \@plus -1ex \@minus -.2ex}%
                 {2.3ex \@plus .2ex}%
                 {\nostretch@\normalfont\hfnt@section}}
\renewcommand\subsection{%
   \@startsection{subsection}{2}{\z@}%
                 {-3.5ex \@plus -1ex \@minus -.2ex}%
                 {2.3ex \@plus .2ex}%
                 {\nostretch@\normalfont\hfnt@subsection}}
\renewcommand\subsubsection{%   
   \@startsection{subsubsection}{3}{\z@}%
                 {-3.25ex\@plus -1ex \@minus -.2ex}%
                 {1.5ex \@plus .2ex}%
                 {\nostretch@\normalfont\hfnt@subsubsection}}
\renewcommand\paragraph{%
   \@startsection{paragraph}{4}{\z@}%
                 {3.25ex \@plus1ex \@minus.2ex}%
                 {-\headingslug}%
                 {\normalfont\normalsize\Bfseries@}}
\renewcommand\subparagraph{%
   \@startsection{subparagraph}{5}{\parindent}%
                 {3.25ex \@plus1ex \@minus .2ex}%
                 {-\headingslug}%
                 {\normalfont\normalsize\Bfseries@}}
                 
\newcounter{point}[chapter]
\renewcommand\thepoint{\thechapter.\@arabic\c@point}
                 
\def\Point@{%
   \@startsection{point}{99}{\z@}%
                 {3.25ex \@plus1ex \@minus .2ex}%
                 {-\headingslug}%
                 {\normalfont\normalsize\Bfseries@}}
                 
\def\point{\@ifstar\spoint@\point@}
\def\spoint@#1{\Point@{#1}}
\def\point@{\refstepcounter{point}%  
   \@ifnextchar\bgroup\point@fill\point@nofill} 
\def\point@fill#1{\def\action@{#1}%
   \ifx\action@\@empty
      \def\action@{\Point@{\thepoint}}%
   \else
      \def\action@{\Point@{\thepoint\ #1}}%
   \fi
   \action@}
\def\point@nofill{\Point@{\thepoint\Dot@}}
\let\pointmark\@gobble
\let\l@point\@gobbletwo
                 

\def\@startsection#1#2#3#4#5#6{\if@noskipsec \leavevmode \fi
   \par \@tempskipa #4\relax
   \@afterindenttrue
   \ifdim \@tempskipa <\z@
      \@tempskipa-\@tempskipa \@afterindentfalse
   \fi
   \if@nobreak \everypar{}\else
      \paradjust@\@tempskipa\sectparstretch
      \addpenalty\@secpenalty \addvspace\@tempskipa
   \fi
   \@ifstar
      {\@ssect{#3}{#4}{#5}{#6}}%
      {\@dblarg{\@sect{#1}{#2}{#3}{#4}{#5}{#6}}}}
      
\def\@sect#1#2#3#4#5#6[#7]#8{%
   \ifnum #2>\c@secnumdepth
      \let\@svsec\@empty\else
      \refstepcounter{#1}%
      \protected@edef\@svsec{\@seccntformat{#1}\relax}%
   \fi           
   \@tempskipa #5\relax
   \ifdim \@tempskipa>\z@
      \begingroup #6\relax  
         \@hangfrom{\hskip #3\relax\@svsec}%
                   {\interlinepenalty \@M #8\par}%
      \endgroup
      \csname #1mark\endcsname{#7}%
         \addcontentsline{toc}{#1}%
            {\ifnum #2>\c@secnumdepth \else
                \protect\numberline{\csname the#1\endcsname}\fi
              #8}%
   \else   
      \def\@svsechd{#6\hskip #3\relax
         \@svsec #8\csname #1mark\endcsname{#7}% 
      \addcontentsline{toc}{#1}%
         {\ifnum #2>\c@secnumdepth \else
             \protect\numberline{\csname the#1\endcsname}\fi
          #8}}%
   \fi
   \@xsect{#5}}
                 
\def\@xsect#1{\@tempskipa #1\relax
   \ifdim \@tempskipa>\z@
      \par \nobreak
      \paradjust@\@tempskipa\sectparstretch 
      \vskip \@tempskipa
      \@afterheading
   \else
      \global\@nobreakfalse \global\@noskipsectrue
      \everypar{\if@noskipsec \global\@noskipsecfalse
                \clubpenalty\@M \hskip -\parindent
                \begingroup \@svsechd \endgroup \unskip
                \@tempskipa #1\relax
                \hskip -\@tempskipa  
                \else \clubpenalty \@clubpenalty 
                \everypar{}\fi}\fi\ignorespaces}
         
             
          
\let\schaptermark\@gobble
   
\if@twoside      
   \def\ps@headings{%
      \def\@oddfoot{\reset@font\hfil\thepage\hfil}\let\@evenfoot\@oddfoot

      \def\@evenhead{\upshape\@revision\hfil\small\slshape\leftmark}%
      \def\@oddhead{\small\slshape\rightmark\hfil\upshape\@revision}%
      \let\@mkboth\@gobbletwo
      \def\chaptermark##1{%
         \markboth{%
            \ifnum \c@secnumdepth >\m@ne
               \@chapapp\ \thechapter.\Slug@
            \fi
            ##1}{}}%
      \def\schaptermark##1{\markboth{##1}{}}%
      \def\sectionmark##1{%
         \markright{%
            \ifnum \c@secnumdepth >\z@
               \thesection\Dot@\Slug@
            \fi
            ##1}}}

   
\else
   \def\ps@headings{%
      \def\@oddfoot{\reset@font\hfil\thepage\hfil}%
      \def\@oddhead{\small\slshape\rightmark\hfil\upshape\@revision}%
      \let\@mkboth\@gobbletwo
      \def\schaptermark##1{\markright{##1}}%
      \def\chaptermark##1{%
         \markright{%
            \ifnum \c@secnumdepth >\m@ne
               \@chapapp\ \thechapter.\Slug@
            \fi
            ##1}}}  
\fi
      
\def\ps@myheadings{% 
   \let\@oddfoot\@empty\let\@evenfoot\@empty
   \def\@evenhead{\upshape\@revision\hfil\small\slshape\leftmark}%
   \def\@oddhead{\small\slshape\rightmark\hfil\upshape\@revision}%
   \let\@mkboth\@gobbletwo
   \let\chaptermark\@gobble
   \let\schaptermark\@gobble
   \let\sectionmark\@gobble}
   
\let\smaller\footnotesize
\let\footnotesize\small
      
      
\newcommand\abbrev{\@ifnextchar[\abbrev@def\abbrev@ref}
\def\abbrev@def[#1]#2{\define@{abbrev@@#2}{#1}}
\def\abbrev@ref#1{%
   \reference@{abbrev@@#1}{\message{[Undefined abbrev: #1]}[#1]}}
               
\def\define@#1{\expandafter\gdef\csname #1\endcsname}
\def\reference@#1#2{%
   \expandafter\let\expandafter\ch@\csname #1\endcsname
   \ifx\ch@\relax    
      \def\action@{#2}%
   \else
      \let\action@\ch@
   \fi
   \action@}
   
{\catcode`\/=13
 \catcode`\|=13
 \catcode`\*=13
 \catcode`\#=13
 \catcode`\%=6
 \gdef\bibliodefs@{\catcode`\/=13 \catcode`\|=13 \catcode`\*=13
\catcode`\#=13
    \def/{\@ifnextchar/{\slash@}{\textit@}}
    \def|{\@ifnextchar|{\bar@}{\textbf@}}
    \def*{\@ifnextchar*{\star@}{\abbrev@ref}}
    \let#\bibentry
    \def\+{\contbiblioline@}\def\\{\newbiblioline@}}
 \gdef\textit@%1/{\textit{\let/\slash@%1}}
 \gdef\textbf@%1|{\textbf{\let|\bar@%1}}
}
\def\slash@#1{/}\def\bar@#1{|}\def\star@{*}
\let\newbiblioline@\newline
\def\contbiblioline@{\newline\hb@xt@1em{\hfil}}
      
      
\newenvironment{biblio}[1][\vskip-1.7em]
   {\chapter*{\bibname}%
    #1\vskip1.7em
    \nostretch@
    \list{}%   
         {\labelwidth\biblabelwidth@\relax
          \labelsep\bibspacer\relax
          \leftmargin\labelwidth
          \advance\leftmargin\bibspacer\relax
          \itemindent\z@
          \usecounter{enumiv}%
          \let\p@enumiv\@empty
          \renewcommand\theenumiv{\@arabic\c@enumiv}}%
    \sloppy\clubpenalty4000\widowpenalty4000\relax
    \sfcode`\.\@m
    \begingroup \bibliodefs@}
   {\endgroup
    \def\@noitemerr{\@latex@warning{Empty `biblio' environment}}%
    \endlist
    \immediate\write\ncaout@{\noexpand\biblw@{\biblabelwidth@}}}
      
\def\bibspacer{2em}
\def\biblabelwidth@{0pt}
\def\testbiblabelwidth@#1{%
   {\settowidth\@tempdima{\@biblabel{#1}}%
    \ifdim\@tempdima>\biblabelwidth@\relax
       \xdef\biblabelwidth@{\the\@tempdima}%
    \fi}}
\def\biblw@#1{\gdef\biblabelwidth@{#1}}
          
          
\def\bibentry{\@ifnextchar[\bibentry@\bibentry@@}
\def\bibentry@[#1]{\testbiblabelwidth@{#1}\@lbibitem[#1]}
\def\bibentry@@#1{\typeout{Missing biblio label: #1}% 
   \bibentry@[?]{#1}}
\def\numericbiblio{%
   \def\bibentry{\@ifnextchar[\numbibentry@\numbibentry@@}}
\def\numbibentry@[#1]{\numbibentry@@}
\def\numbibentry@@{\testlabelwidth@{\@arabic\c@enumiv}\@bibitem} 
    
    
\renewenvironment{theindex}
   {\columnseprule \z@
    \columnsep 35\p@
    \twocolumn[\chapter*{\indexname}]%
    \thispagestyle{plain}\parindent\z@
    \nostretch@
    \parskip\z@ \@plus .3\p@\relax
    \let\item\@idxitem}
   {\onecolumn}
\endinput 
%%        
%% End of file `lnotes.cls'.


   






            
      
      
       
       
        
      
     
         
   
         
          
             
       
     
     
    
      
           
         

